# std::map< Key, Type, Compare, Alloc > Class Template Reference
[Containers, Associative Containers]

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time. More...

`#include <stl_map.h>`

Inheritance diagram for std::map< Key, Type, Compare, Alloc >:

[legend]
List of all members.

## Public Member Functions

| map ()
| Default constructor creates no elements.
| map (const Compare &comp, const allocator_type &a=allocator_type())
| Default constructor creates no elements.
| map (const map &x)
| Map copy constructor.
template<typename InputIterator> | map (InputIterator first, InputIterator last)
| Builds a map from a range.
template<typename InputIterator> | map (InputIterator first, InputIterator last, const Compare &comp, const allocator_type &a=allocator_type())
| Builds a map from a range.
map & | operator= (const map &x)
| Map assignment operator.
allocator_type | get_allocator () const
| Get a copy of the memory allocation object.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
bool | empty () const
size_type | size () const
size_type | max_size () const
mapped_type & | operator[] (const key_type &__k)
| Subscript ( ``[] ) access to map data.
pair< iterator, bool > | insert (const value_type &x)
| Attempts to insert a std::pair into the map.
iterator | insert (iterator position, const value_type &x)
| Attempts to insert a std::pair into the map.
template<typename InputIterator> void | insert (InputIterator first, InputIterator last)
| A template function that attemps to insert a range of elements.
void | erase (iterator position)
| Erases an element from a map.
size_type | erase (const key_type &x)
| Erases elements according to the provided key.
void | erase (iterator first, iterator last)
| Erases a [first,last) range of elements from a map.
void | swap (map &x)
| Swaps data with another map.
void | clear ()
key_compare | key_comp () const
value_compare | value_comp () const
iterator | find (const key_type &x)
| Tries to locate an element in a map.
const_iterator | find (const key_type &x) const
| Tries to locate an element in a map.
size_type | count (const key_type &x) const
| Finds the number of elements with given key.
iterator | lower_bound (const key_type &x)
| Finds the beginning of a subsequence matching given key.
const_iterator | lower_bound (const key_type &x) const
| Finds the beginning of a subsequence matching given key.
iterator | upper_bound (const key_type &x)
| Finds the end of a subsequence matching given key.
const_iterator | upper_bound (const key_type &x) const
| Finds the end of a subsequence matching given key.
pair< iterator, iterator > | equal_range (const key_type &x)
| Finds a subsequence matching given key.
pair< const_iterator, const_iterator > | equal_range (const key_type &x) const
| Finds a subsequence matching given key.

## Detailed Description

### template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
class std::map< Key, Type, Compare, Alloc >

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time.

Meets the requirements of a container, a reversible container, and an associative container (using unique keys). For a `map<Key,T>` the key_type is Key, the mapped_type is T, and the value_type is std::pair<const Key,T>.

Maps support bidirectional iterators.

Definition at line 91 of file stl_map.h.

## Constructor & Destructor Documentation

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
std::map< Key, Type, Compare, Alloc >::map | ( |  | ) | `[inline]`

| Default constructor creates no elements. Definition at line 147 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
std::map< Key, Type, Compare, Alloc >::map | ( | const Compare & | comp,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 155 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
std::map< Key, Type, Compare, Alloc >::map | ( | const map< Key, Type, Compare, Alloc > & | x | ) | `[inline]`

Map copy constructor.

Parameters:

  | x | A map of identical element and allocator types.

The newly-created map uses a copy of the allocation object used by x.

Definition at line 165 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
template<typename InputIterator>
std::map< Key, Type, Compare, Alloc >::map | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Builds a map from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a map consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 178 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
template<typename InputIterator>
std::map< Key, Type, Compare, Alloc >::map | ( | InputIterator | first,
|  | InputIterator | last,
|  | const Compare & | comp,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Builds a map from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | comp | A comparison functor.
  | a | An allocator object.

Create a map consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 194 of file stl_map.h.

## Member Function Documentation

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_iterator std::map< Key, Type, Compare, Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys. Definition at line 243 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
iterator std::map< Key, Type, Compare, Alloc >::begin | ( |  | ) | `[inline]`

| Returns a read/write iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys. Definition at line 234 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
void std::map< Key, Type, Compare, Alloc >::clear | ( |  | ) | `[inline]`

| Erases all elements in a map. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 464 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
size_type std::map< Key, Type, Compare, Alloc >::count | ( | const key_type & | x | ) | const`[inline]`

Finds the number of elements with given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Number of elements with specified key.

This function only makes sense for multimaps; for map the result will either be 0 (not present) or 1 (present).

Definition at line 524 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
bool std::map< Key, Type, Compare, Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the map is empty. (Thus begin() would equal end().) Definition at line 304 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_iterator std::map< Key, Type, Compare, Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys. Definition at line 260 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
iterator std::map< Key, Type, Compare, Alloc >::end | ( |  | ) | `[inline]`

| Returns a read/write iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys. Definition at line 251 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
pair<const_iterator,const_iterator> std::map< Key, Type, Compare, Alloc >::equal_range | ( | const key_type & | x | ) | const`[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multimaps.

Definition at line 612 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
pair<iterator,iterator> std::map< Key, Type, Compare, Alloc >::equal_range | ( | const key_type & | x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multimaps.

Definition at line 593 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
void std::map< Key, Type, Compare, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) | `[inline]`

Erases a [first,last) range of elements from a map.

Parameters:

  | first | Iterator pointing to the start of the range to be erased.
  | last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 439 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
size_type std::map< Key, Type, Compare, Alloc >::erase | ( | const key_type & | x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  | x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all the elements located by the given key from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 424 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
void std::map< Key, Type, Compare, Alloc >::erase | ( | iterator | position | ) | `[inline]`

Erases an element from a map.

Parameters:

  | position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 409 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_iterator std::map< Key, Type, Compare, Alloc >::find | ( | const key_type & | x | ) | const`[inline]`

Tries to locate an element in a map.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 512 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
iterator std::map< Key, Type, Compare, Alloc >::find | ( | const key_type & | x | ) | `[inline]`

Tries to locate an element in a map.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 497 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
allocator_type std::map< Key, Type, Compare, Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 224 of file stl_map.h. Referenced by std::map< Key, Type, Compare, Allocator >::get_allocator().

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
template<typename InputIterator>
void std::map< Key, Type, Compare, Alloc >::insert | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

A template function that attemps to insert a range of elements.

Parameters:

  | first | Iterator pointing to the start of the range to be inserted.
  | last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 396 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
iterator std::map< Key, Type, Compare, Alloc >::insert | ( | iterator | position,
|  | const value_type & | x
| ) | `[inline]`

Attempts to insert a std::pair into the map.

Parameters:

  | position | An iterator that serves as a hint as to where the pair should be inserted.
  | x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the element with key of x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on "hinting".

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 383 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
pair<iterator,bool> std::map< Key, Type, Compare, Alloc >::insert | ( | const value_type & | x | ) | `[inline]`

Attempts to insert a std::pair into the map.

Parameters:

  | x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the map. A map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the map.

Insertion requires logarithmic time.

Definition at line 359 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
key_compare std::map< Key, Type, Compare, Alloc >::key_comp | ( |  | ) | const`[inline]`

| Returns the key comparison object out of which the map was constructed. Definition at line 473 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_iterator std::map< Key, Type, Compare, Alloc >::lower_bound | ( | const key_type & | x | ) | const`[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 554 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
iterator std::map< Key, Type, Compare, Alloc >::lower_bound | ( | const key_type & | x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 539 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
size_type std::map< Key, Type, Compare, Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the maximum size of the map. Definition at line 314 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
map& std::map< Key, Type, Compare, Alloc >::operator= | ( | const map< Key, Type, Compare, Alloc > & | x | ) | `[inline]`

Map assignment operator.

Parameters:

  | x | A map of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 216 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
mapped_type& std::map< Key, Type, Compare, Alloc >::operator[] | ( | const key_type & | __k | ) | `[inline]`

Subscript ( ``[] ) access to map data.

Parameters:

  | k | The key for which data should be retrieved.

Returns:
  A reference to the data of the (key,data) pair.

Allows for easy lookup with the subscript ( ``[] ) operator. Returns data associated with the key specified in subscript. If the key does not exist, a pair with that key is created using default values, which is then returned.

Lookup requires logarithmic time.

Definition at line 331 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_reverse_iterator std::map< Key, Type, Compare, Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys. Definition at line 278 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
reverse_iterator std::map< Key, Type, Compare, Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys. Definition at line 269 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_reverse_iterator std::map< Key, Type, Compare, Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys. Definition at line 296 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
reverse_iterator std::map< Key, Type, Compare, Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys. Definition at line 287 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
size_type std::map< Key, Type, Compare, Alloc >::size | ( |  | ) | const`[inline]`

| Returns the size of the map. Definition at line 309 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
void std::map< Key, Type, Compare, Alloc >::swap | ( | map< Key, Type, Compare, Alloc > & | x | ) | `[inline]`

Swaps data with another map.

Parameters:

  | x | A map of the same element and allocator types.

This exchanges the elements between two maps in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 454 of file stl_map.h.

Referenced by std::swap().

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
const_iterator std::map< Key, Type, Compare, Alloc >::upper_bound | ( | const key_type & | x | ) | const`[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first iterator greater than key, or end().

Definition at line 574 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
iterator std::map< Key, Type, Compare, Alloc >::upper_bound | ( | const key_type & | x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Definition at line 564 of file stl_map.h.

template<typename Key, typename Type, typename Compare = less<Key>, typename Alloc = allocator<pair<const Key, Type> >>
value_compare std::map< Key, Type, Compare, Alloc >::value_comp | ( |  | ) | const`[inline]`

| Returns a value comparison object, built from the key comparison object out of which the map was constructed. Definition at line 481 of file stl_map.h.

The documentation for this class was generated from the following file:

- stl_map.h